//
// Copyright (c) ZeroC, Inc. All rights reserved.
//
//
// Ice version 3.7.2
//
// <auto-generated>
//
// Generated from file `IntegerOverflowException.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//


using _System = global::System;

#pragma warning disable 1591

namespace Smartswitch
{
    namespace Peer
    {
        namespace UserGeneration
        {
            /// <summary>
            /// @brief This exception is thrown on integer overflow on unique consecutive alphanumeric User name generation.
            /// A user generation profile might have been configured to generate a new User with unique consecutive alphanumeric name.
            /// To fulfill this, Smartswitch obtains the numeric part of the last generated User.
            /// Then Smartswitch increments it by 1 and assigns to a new User.
            /// If during incrementing the 64-bit numeric limits are overflown, this exception is thrown.
            ///
            /// </summary>

            [global::System.Runtime.InteropServices.ComVisible(false)]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1032")]
            [global::System.Serializable]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
            public partial class IntegerOverflowException : global::Smartswitch.GenericException
            {
                #region Constructors

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public IntegerOverflowException()
                {
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public IntegerOverflowException(global::System.Exception ex) : base(ex)
                {
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public IntegerOverflowException(global::System.Runtime.Serialization.SerializationInfo info, global::System.Runtime.Serialization.StreamingContext context) : base(info, context)
                {
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public IntegerOverflowException(string description, string solution) : base(description, solution)
                {
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public IntegerOverflowException(string description, string solution, global::System.Exception ex) : base(description, solution, ex)
                {
                }

                #endregion

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public override string ice_id()
                {
                    return "::Smartswitch::Peer::UserGeneration::IntegerOverflowException";
                }

                #region Object members

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public override int GetHashCode()
                {
                    int h_ = base.GetHashCode();
                    global::IceInternal.HashUtil.hashAdd(ref h_, "::Smartswitch::Peer::UserGeneration::IntegerOverflowException");
                    return h_;
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public override bool Equals(object other)
                {
                    if(other == null)
                    {
                        return false;
                    }
                    if(object.ReferenceEquals(this, other))
                    {
                        return true;
                    }
                    IntegerOverflowException o = other as IntegerOverflowException;
                    if(o == null)
                    {
                        return false;
                    }
                    if(!base.Equals(other))
                    {
                        return false;
                    }
                    return true;
                }

                #endregion

                #region Comparison members

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public static bool operator==(IntegerOverflowException lhs, IntegerOverflowException rhs)
                {
                    return Equals(lhs, rhs);
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public static bool operator!=(IntegerOverflowException lhs, IntegerOverflowException rhs)
                {
                    return !Equals(lhs, rhs);
                }

                #endregion

                #region Marshaling support

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                protected override void iceWriteImpl(global::Ice.OutputStream ostr_)
                {
                    ostr_.startSlice("::Smartswitch::Peer::UserGeneration::IntegerOverflowException", -1, false);
                    ostr_.endSlice();
                    base.iceWriteImpl(ostr_);
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                protected override void iceReadImpl(global::Ice.InputStream istr_)
                {
                    istr_.startSlice();
                    istr_.endSlice();
                    base.iceReadImpl(istr_);
                }

                #endregion
            }
        }
    }
}
