//
// Copyright (c) ZeroC, Inc. All rights reserved.
//
//
// Ice version 3.7.2
//
// <auto-generated>
//
// Generated from file `WeakPasswordException.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//


using _System = global::System;

#pragma warning disable 1591

namespace Smartswitch
{
    namespace Peer
    {
        namespace UserGeneration
        {
            /// <summary>
            /// @brief This exception is thrown when there is no more attempts left to generate a strong password for a User.
            /// When generating a User, Smartswitch tries to generate random password for a User basing on password generation template which is set in a User generation profile.
            /// Then Smartswitch checks if a newly generated password is strong enough.
            /// If the check fails, Smartswitch tries to generate another random password.
            /// The amount of attempts to generate a strong password is defined at User generation profile.
            /// If Smartswitch is unable to generate a strong password in a given amount of attempts, this exception is thrown.
            ///
            /// </summary>

            [global::System.Runtime.InteropServices.ComVisible(false)]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1032")]
            [global::System.Serializable]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
            [global::System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
            public partial class WeakPasswordException : global::Smartswitch.GenericException
            {
                #region Slice data members

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public int attempts;

                #endregion

                #region Constructors

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                private void _initDM()
                {
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public WeakPasswordException()
                {
                    _initDM();
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public WeakPasswordException(global::System.Exception ex) : base(ex)
                {
                    _initDM();
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public WeakPasswordException(global::System.Runtime.Serialization.SerializationInfo info, global::System.Runtime.Serialization.StreamingContext context) : base(info, context)
                {
                    this.attempts = info.GetInt32("attempts");
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                private void _initDM(int attempts)
                {
                    this.attempts = attempts;
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public WeakPasswordException(string description, string solution, int attempts) : base(description, solution)
                {
                    _initDM(attempts);
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public WeakPasswordException(string description, string solution, int attempts, global::System.Exception ex) : base(description, solution, ex)
                {
                    _initDM(attempts);
                }

                #endregion

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public override string ice_id()
                {
                    return "::Smartswitch::Peer::UserGeneration::WeakPasswordException";
                }

                #region Object members

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public override int GetHashCode()
                {
                    int h_ = base.GetHashCode();
                    global::IceInternal.HashUtil.hashAdd(ref h_, "::Smartswitch::Peer::UserGeneration::WeakPasswordException");
                    global::IceInternal.HashUtil.hashAdd(ref h_, attempts);
                    return h_;
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public override bool Equals(object other)
                {
                    if(other == null)
                    {
                        return false;
                    }
                    if(object.ReferenceEquals(this, other))
                    {
                        return true;
                    }
                    WeakPasswordException o = other as WeakPasswordException;
                    if(o == null)
                    {
                        return false;
                    }
                    if(!base.Equals(other))
                    {
                        return false;
                    }
                    if(!this.attempts.Equals(o.attempts))
                    {
                        return false;
                    }
                    return true;
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public override void GetObjectData(global::System.Runtime.Serialization.SerializationInfo info, global::System.Runtime.Serialization.StreamingContext context)
                {
                    info.AddValue("attempts", this.attempts);

                    base.GetObjectData(info, context);
                }

                #endregion

                #region Comparison members

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public static bool operator==(WeakPasswordException lhs, WeakPasswordException rhs)
                {
                    return Equals(lhs, rhs);
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                public static bool operator!=(WeakPasswordException lhs, WeakPasswordException rhs)
                {
                    return !Equals(lhs, rhs);
                }

                #endregion

                #region Marshaling support

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                protected override void iceWriteImpl(global::Ice.OutputStream ostr_)
                {
                    ostr_.startSlice("::Smartswitch::Peer::UserGeneration::WeakPasswordException", -1, false);
                    ostr_.writeInt(attempts);
                    ostr_.endSlice();
                    base.iceWriteImpl(ostr_);
                }

                [global::System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.7.2")]
                protected override void iceReadImpl(global::Ice.InputStream istr_)
                {
                    istr_.startSlice();
                    attempts = istr_.readInt();
                    istr_.endSlice();
                    base.iceReadImpl(istr_);
                }

                #endregion
            }
        }
    }
}
